# À vous de créer :
# 1. Un VPC personnalisé avec auto_create_subnetworks = false
# 2. Trois sous-réseaux (frontend, backend, database)
# 3. Règles de firewall :
#    - HTTP/HTTPS vers frontend
#    - SSH vers toutes les instances
#    - Port 8000 de frontend vers backend
#    - Port 3306 de backend vers database


# VPC
resource "google_compute_network" "vpc" {
  name                    = "mon-vpc"
  auto_create_subnetworks = false
}

# Sous-réseau
resource "google_compute_subnetwork" "frontend" {
  name          = "mon-frontend"
  network       = google_compute_network.vpc.id
  ip_cidr_range = var.frontend_cidr
  region        = var.region
}

# Sous-réseau
resource "google_compute_subnetwork" "backend" {
  name          = "mon-backend"
  network       = google_compute_network.vpc.id
  ip_cidr_range = var.backend_cidr
  region        = var.region
}

# Sous-réseau
resource "google_compute_subnetwork" "database" {
  name          = "ma-database"
  network       = google_compute_network.vpc.id
  ip_cidr_range = var.database_cidr
  region        = var.region
}




# firewall



resource "google_compute_firewall" "frontend_firewall" {
  name    = "frontend"
  network = google_compute_network.vpc.id

  allow {
    protocol = "tcp"
    ports    = ["80", "443"]
  }

  source_ranges = ["0.0.0.0/0"]
  target_tags   = ["frontend"]
}


resource "google_compute_firewall" "backend_firewall" {
  name    = "backend"
  network = google_compute_network.vpc.id

  allow {
    protocol = "tcp"
    ports    = ["8000"]
  }

  source_tags = ["frontend"]
  target_tags   = ["backend"]
}


resource "google_compute_firewall" "database_firewall" {
  name    = "database"
  network = google_compute_network.vpc.id

  allow {
    protocol = "tcp"
    ports    = ["3306"]
  }

  source_tags = ["backend"]
  target_tags   = ["database"]
}


resource "google_compute_firewall" "ssh_firewall" {
  name    = "ssh"
  network = google_compute_network.vpc.id

  allow {
    protocol = "tcp"
    ports    = ["22"]
  }

  source_ranges = ["0.0.0.0/0"]
  target_tags   = ["ssh"]
}

